<template>
  <div>
    <div class="flex justify-between items-top">
      <div class="text-h4 q-mb-md">
        Jízdní řády
      </div>

      <div>
        <q-btn
          color="accent"
          icon="directions_transit_filled"
          icon-right="add"
          label="Přidat"
          size="md"
          @click="addClick"
        />
      </div>
    </div>

    <q-table
      grid
      :rows="rows"
      :columns="columns"
      row-key="name"
      :pagination="initialPagination"
      :loading="loadingTable"
    >
      <template #item="props">
        <div class="q-pa-xs col-xs-12 col-sm-6 col-md-4">
          <q-card>
            <q-card-section class="text-center">
              <strong>{{ props.row.name }}</strong>
              <div>
                {{ props.row.sequence ? 'Spouštět za sebou' : 'Spouštět současně' }}
              </div>
            </q-card-section>
            <q-separator />
            <q-card-section class="flex flex-center">
              <q-btn
                class="q-ml-xs q-mb-xs"
                color="primary"
                label="Upravit"
                size="sm"
                @click="onUpdate(props.row.id)"
              >
                <template #loading>
                  <q-spinner-gears />
                </template>
              </q-btn>

              <q-btn
                class="q-ml-xs q-mb-xs"
                color="negative"
                label="Smazat"
                size="sm"
                @click="onDelete(props.row.id)"
              >
                <template #loading>
                  <q-spinner-gears />
                </template>
              </q-btn>
            </q-card-section>
          </q-card>
        </div>
      </template>

      <template #loading>
        <q-inner-loading
          showing
          color="primary"
        />
      </template>
    </q-table>
  </div>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import { TimetableModel } from 'web_trains_types'

import TimetableAddDialog from '@/components/Timetable/TimetableAddDialog.vue'
import { timetableService } from '@/service'

const columns = [
  {
    name: 'name',
    field: 'timetable.name',
    label: 'Název',
    required: true,
    sortable: true
  },
  {
    name: 'sequence',
    field: 'timetable.sequence',
    label: 'Spustit za sebou',
    required: true,
    sortable: true
  }
]

const initialPagination = {
  sortBy: 'name',
  descending: false,
  page: 1,
  rowsPerPage: 9
}

export default {
  name: 'Timetable',
  emits: [
    'reload'
  ],
  setup (): any {
    const $q = useQuasar()

    const loadingTable = ref(true)
    const rows = ref<TimetableModel[]>()

    const loadData = () => {
      loadingTable.value = true

      timetableService.getAll()
        .then((data) => {
          rows.value = data
        })
        .finally(() => {
          loadingTable.value = false
        })
    }

    const addClick = () => {
      $q.dialog({
        component: TimetableAddDialog
      })
        .onOk(loadData)
    }

    loadData()

    const onDelete = (id: number) => {
      loadingTable.value = true

      timetableService.del(id)
        .then(() => {
          if (rows.value === undefined) {
            return
          }

          _.remove(rows.value, (obj) => obj.id === id)

          $q.notify({
            message: 'Jízdní řád smazán',
            type: 'positive'
          })
        })
        .finally(() => { loadingTable.value = false })
    }

    const onUpdate = (id: number) => {
      $q.dialog({
        component: TimetableAddDialog,
        componentProps: {
          id: id
        }
      })
        .onOk(loadData)
    }

    return {
      addClick,
      columns,
      initialPagination,
      loadingTable,
      rows,
      loadData,
      onDelete,
      onUpdate
    }
  }
}

</script>
